/*****************************************************************************
 * Copyright (C) 1997-2007, Mark Hummel
 * This file is part of Vrq.
 *
 * Vrq is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * Vrq is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, 
 * Boston, MA  02110-1301  USA
 *****************************************************************************
 */
/******************************************************************************
 *
 *
 *	   cbuilder.hpp
 *		- definition for verilog tree builder
 *
 ******************************************************************************
 */

#ifndef CBUILDER_HPP
#define CBUILDER_HPP

#include "cbackend.h"

class CDecl;
class CPort;
class CVar;
class CNode;
class CNet;

class CBuilder : public CBackend 
{
private:
public:
	CBuilder( void );
	virtual char* GetToolName( void );
	virtual char* GetToolDescription( void );
	virtual int ResolveModules() { return TRUE; }
        virtual int ResolveInstance( CModule*, CInstance* );
	virtual void Activate();
	virtual void Process( list<CElement>& inputList,
			      list<CElement>& outputList );
};

#endif // CBUILDER_HPP
