/*-----------------------------------------------------------------------------
 * 	Copyright (c) 1997-2010 Mark Hummel DBA Raquette Software.
 *		All rights reserved
 *
 *    This file contains source code written by Raquette Software, 
 *    68 Stewart Street, Franklin MA 02038. It may not be used without 
 *    express written permission. The expression of the information 
 *    contained herein is protected under federal copyright laws and 
 *    all copying without permission is prohibited and may be subject 
 *    to criminal penalties. The Author assumes no responsibility for 
 *    errors, omissions, or damages caused by the use of these programs 
 *    or from use of the information contained herein.
 *
 *-----------------------------------------------------------------------------
 */
/******************************************************************************
 *
 *
 *	   cfilter.h
 *		- definition for tool to filter elements of a design
 *
 ******************************************************************************
 */

#ifndef FILTER_H
#define FILTER_H

#include "cbackend.h"
#include "cnode.h"
#include <map>

class CFilter : public CBackend 
{
private:
	map<string,NodeOp_t> keepMap;
	map<string,NodeOp_t> deleteMap;
public:
	CFilter( void );
	virtual char* GetToolName( void );
	virtual char* GetToolDescription( void );
	virtual int ResolveModules() { return FALSE; }
	virtual int ResolveInstance( CModule*, CInstance* ) { return FALSE; }
	virtual void Activate() {}
	virtual void Process( list<CElement>& inputList,
			      list<CElement>& outputList );
};

#endif // CFILTER_H
