/*-----------------------------------------------------------------------------
 * 	Copyright (c) 1997-2003 Mark Hummel DBA Raquette Software.
 *		All rights reserved
 *
 *    This file contains source code written by Raquette Software, 
 *    68 Stewart Street, Franklin MA 02038. It may not be used without 
 *    express written permission. The expression of the information 
 *    contained herein is protected under federal copyright laws and 
 *    all copying without permission is prohibited and may be subject 
 *    to criminal penalties. The Author assumes no responsibility for 
 *    errors, omissions, or damages caused by the use of these programs 
 *    or from use of the information contained herein.
 *
 *-----------------------------------------------------------------------------
 */
/******************************************************************************
 *
 *
 *	   cflatten.hpp
 *		- definition for tool to flatten a design
 *
 ******************************************************************************
 */

#ifndef FLATTEN_PP
#define FLATTEN_HPP

#include "cbackend.h"

class CDecl;
class CPort;
class CVar;
class CNode;
class CNet;

class CFlatten : public CBackend 
{
private:
public:
	CFlatten( void );
	virtual char* GetToolName( void );
	virtual char* GetToolDescription( void );
	virtual int RequireModuleResolution() { return FALSE; }
	virtual int ResolveModules() { return TRUE; }
	virtual int ResolveInstance( CModule*, CInstance* );
	virtual void Activate() {}
	virtual void Process( list<CElement>& inputList,
			      list<CElement>& outputList );
};

#endif // CFLATTEN_HPP
