/*-----------------------------------------------------------------------------
 * 	Copyright (c) 1997-2010 Mark Hummel DBA Raquette Software.
 *		All rights reserved
 *
 *    This file contains source code written by Raquette Software, 
 *    68 Stewart Street, Franklin MA 02038. It may not be used without 
 *    express written permission. The expression of the information 
 *    contained herein is protected under federal copyright laws and 
 *    all copying without permission is prohibited and may be subject 
 *    to criminal penalties. The Author assumes no responsibility for 
 *    errors, omissions, or damages caused by the use of these programs 
 *    or from use of the information contained herein.
 *
 *-----------------------------------------------------------------------------
 */
/******************************************************************************
 *
 *
 *	   crectify.h
 *		- definition for tool to rectify x's out of a design
 *
 ******************************************************************************
 */

#ifndef RECTIFY_H
#define RECTIFY_H

#include "cbackend.h"
#include "cnode.h"
#include <map>

class CRectify : public CBackend 
{
private:
	string defaultAttribute;
	int    defaultValue;
        int    deleteDeclPragmas;
public:
	CRectify( void );
	virtual char* GetToolName( void );
	virtual char* GetToolDescription( void );
	virtual int ResolveModules() { return FALSE; }
	virtual int ResolveInstance( CModule*, CInstance* ) { return FALSE; }
	virtual void Activate() {}
	virtual void Process( list<CElement>& inputList,
			      list<CElement>& outputList );
	int DefaultValue() { return defaultValue; }
	const char* DefaultAttribute() { return defaultAttribute.c_str(); }
};

#endif // CRECTIFY_H
