/*-----------------------------------------------------------------------------
 * 	Copyright (c) 2008 Mark Hummel DBA Raquette Software.
 *		All rights reserved
 *
 *    This file contains source code written by Raquette Software, 
 *    68 Stewart Street, Franklin MA 02038. It may not be used without 
 *    express written permission. The expression of the information 
 *    contained herein is protected under federal copyright laws and 
 *    all copying without permission is prohibited and may be subject 
 *    to criminal penalties. The Author assumes no responsibility for 
 *    errors, omissions, or damages caused by the use of these programs 
 *    or from use of the information contained herein.
 *
 *-----------------------------------------------------------------------------
 */
/******************************************************************************
 *
 *
 *	   csim.h
 *		- definition for simulation tool
 *
 ******************************************************************************
 */

#ifndef CSIM_H
#define CSIM_H

#include "cbackend.h"
#include "veriwellinterface.h"

class CSim : public CBackend 
{
private:
    int interactive;
    int compileOnly;
    int traceFlag;
    delay_type delayType;
public:
	CSim( void );
	virtual int HideTool( void ) { return FALSE; }
	virtual char* GetToolName( void );
	virtual char* GetToolDescription( void );
	virtual int ResolveModules() { return TRUE; }
	virtual int IgnoreVrqComments() { return TRUE; }
	virtual void Activate() {}
	virtual int AcceptAllPlusArgs() { return TRUE; }
	virtual int ResolveInstance( CModule*, CInstance* );
	virtual void Logfile( FILE* aLogfile );
	virtual void Process( list<CElement>& inputList,
			      list<CElement>& outputList );
};

#endif // CSIM_H
