/*-----------------------------------------------------------------------------
 * 	Copyright (c) 1997-2002 Mark Hummel DBA Raquette Software.
 *		All rights reserved
 *
 *    This file contains source code written by Raquette Software, 
 *    68 Stewart Street, Franklin MA 02038. It may not be used without 
 *    express written permission. The expression of the information 
 *    contained herein is protected under federal copyright laws and 
 *    all copying without permission is prohibited and may be subject 
 *    to criminal penalties. The Author assumes no responsibility for 
 *    errors, omissions, or damages caused by the use of these programs 
 *    or from use of the information contained herein.
 *
 *-----------------------------------------------------------------------------
 */
/******************************************************************************
 *
 *
 *	   cstats.hpp
 *		- definition for simulation tool
 *
 ******************************************************************************
 */

#ifndef CSTATS_HPP
#define CSTATS_HPP

#include "cbackend.h"
#include <set>

/*
 * internal structural representation
 */

class CModule;
class CVar;

struct StatsModule {
	CModule*      cmodule;
	const char*   name;
	StatsModule*  next;
	StatsModule*  parent;
	StatsModule*  children;
	int	      registerBitCount;
	int	      cumulativeRegisterBitCount;
};

class CStats : public CBackend 
{
private:
public:
	CStats( void );
	virtual char* GetToolName( void );
	virtual char* GetToolDescription( void );
	virtual int ResolveModules() { return TRUE; }
	virtual int ResolveInstance( CModule*, CInstance* ) { return TRUE; }
	virtual void Activate() {}
	virtual void Process( list<CElement>& inputList,
			      list<CElement>& outputList );
};

#endif // CSTATS_HPP
