/*****************************************************************************
 * Copyright (C) 1997-2007, Mark Hummel
 * This file is part of Vrq.
 *
 * Vrq is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * Vrq is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, 
 * Boston, MA  02110-1301  USA
 *****************************************************************************
 */
/******************************************************************************
 *
 *
 *	   cgenvar.ccc
 *		- class definition of genvar variable 
 *
 ******************************************************************************
 */

#include "cgenvar.h"
#include "cnode.h"




/****************************************************
	Constructor
*****************************************************/
CGenvar::CGenvar( CSymbol* name, Coord_t* aLoc ) :
	CDecl( name, aLoc, eGENVAR, NULL, eFLAG_PRAGMA ) {
}

/****************************************************
	Clone
	- Return a copy of this declaration.
*****************************************************/
CDecl* CGenvar::Clone( CObstack* heap )
{
    CGenvar* clone = new(heap) CGenvar( GetSymbol(), GetCoord() );
    clone->Copy( heap, *this );
    return clone;
}

/****************************************************
	Dump
*****************************************************/
void	CGenvar::Dump( FILE* f )
{
	fprintf( f, "%s: %s, defined in ", 
		declName[GetType()],
		GetName() );
	CDecl::Dump( f );
	fprintf( f, "\n" );
}	
