/*****************************************************************************
 * Copyright (C) 1997-2010, Mark Hummel
 * This file is part of Vrq.
 *
 * Vrq is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * Vrq is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, 
 * Boston, MA  02110-1301  USA
 *****************************************************************************
 */
/******************************************************************************
 *
 *
 *	   cproxytype.h
 *		- abstract class for referring to other types
 *
 *
 ******************************************************************************
 */

#include "cproxytype.h"


/**
 * Create a new copy with a deep copy. 
 * \param heap heap to use for allocation.
 */
CDataType* CProxyType::Clone( CObstack* heap )
{
    list<CNode*> dummy;
    CProxyType* clone = new(heap) CProxyType( symbol, NULL, dummy );
    clone->Copy( heap, *this ); 
    return clone;
}
/**
 * Perform deep copy of given object to this one
 * This should never be call directly, only by subclasses.
 * \param heap heap to use for allocation.
 * \param o declaration to copy.
 */
void CProxyType::Copy( CObstack* heap, const CProxyType& o )
{
    CDataType::Copy( heap, o );
    decl = o.decl;
}

