/*****************************************************************************
 * Copyright (C) 1997-2007, Mark Hummel
 * This file is part of Vrq.
 *
 * Vrq is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * Vrq is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, 
 * Boston, MA  02110-1301  USA
 *****************************************************************************
 */
/******************************************************************************
 *
 *
 *	   cspecify.hpp
 *		- class definition of specify block
 *		  definition nodes
 *
 ******************************************************************************
 */

#ifndef CSPECIFY_HPP
#define CSPECIFY_HPP

#include <stdio.h>
#include <vector> 
#include "glue.h"
#include "cdecl.h"
#include "csymtab.h"
#include "cblock.h"




/**
 * Declaration object for specify blocks
 */
class CSpecify: public CBlock
{
public:
	/**
 	 * Create a specify block.
 	 * \param aLoc file coordinates of specify block.
 	 */
	CSpecify( Coord_t* aLoc );
	/**
 	 * Dump specifiy block info to file descriptor.
 	 * \param f file descriptor.
 	 */
	virtual void Dump( FILE* f );
};

#endif // CSPECIFY_HPP
