/*****************************************************************************
 * Copyright (C) 1997-2010, Mark Hummel
 * This file is part of Vrq.
 *
 * Vrq is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * Vrq is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, 
 * Boston, MA  02110-1301  USA
 *****************************************************************************
 */
/******************************************************************************
 *
 *
 *	   ctypedef.cc
 *		- class definition of type definition
 *
 ******************************************************************************
 */

#include "ctypedef.h"
#include "cnode.h"




/****************************************************
	Constructor
*****************************************************/
CTypedef::CTypedef( CSymbol* name, Coord_t* aLoc, CDataType* dataType ) :
	CDecl( name, aLoc, eTYPEDEF, dataType, Or(eFLAG_ARRAY,eFLAG_DATATYPE) )
{
}

/****************************************************
	Clone
	- Return a copy of this declaration.
*****************************************************/
CDecl* CTypedef::Clone( CObstack* heap )
{
    CTypedef* clone = new(heap) CTypedef( GetSymbol(), GetCoord(), GetDataType() );
    clone->Copy( heap, *this );
    return clone;
}

/****************************************************
	Dump
*****************************************************/
void	CTypedef::Dump( FILE* f )
{
	fprintf( f, "%s: %s, defined in ", 
		declName[GetType()],
		GetName() );
	CDecl::Dump( f );
	fprintf( f, "\n" );
}	
