/*****************************************************************************
 * Copyright (C) 1997-2007, Mark Hummel
 * This file is part of Vrq.
 *
 * Vrq is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * Vrq is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, 
 * Boston, MA  02110-1301  USA
 *****************************************************************************
 */
/******************************************************************************
 *
 *
 *	   cxprop.hpp
 *		- definition for verilog x propagation insertion tool
 *
 ******************************************************************************
 */

#ifndef XPROP_HPP
#define XPROP_HPP

#include "cbackend.h"

class CDecl;
class CPort;
class CReg;
class CNode;
class CNet;

class CXProp : public CBackend 
{
public:
	CXProp( void );
	virtual char* GetToolName( void );
	virtual char* GetToolDescription( void );
	virtual int ResolveModules() { return FALSE; }
	virtual int ResolveInstance( CModule*, CInstance* ) { return FALSE; }
	virtual void Activate() {}
	virtual void Process( list<CElement>& inputList,
			      list<CElement>& outputList );
};

#endif // CXPROP_HPP
